<template>
  <transition name="fade" appear>
    <div class="modal">
      <transition name="slide" appear>
        <div class="box">
          <span>
            {{ status == formStatus.sent ? sentTitle : title }}
            <router-link class="close" :to="back">
              <font-awesome-icon :icon="icons.faTimes" />
            </router-link>
          </span>
          <div class="subbox">
            <slot v-if="status != formStatus.sent"></slot>
            <div v-if="status == formStatus.sent" class="done">
              <font-awesome-icon class="icon" :icon="icons.faCheckCircle" />
            </div>
          </div>
        </div>
      </transition>
    </div>
  </transition>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faTimes, faCheckCircle } from "@fortawesome/free-solid-svg-icons";

import { FormStatus } from "@/views/new-views/NewRecord.ts";

@Options({
  props: {
    title: {
      type: String,
      required: true,
    },
    back: {
      type: String,
      required: true,
    },
    status: {
      type: Number,
      required: true,
    },
    sentTitle: {
      type: String,
    },
  },
  components: {
    FontAwesomeIcon,
  },
})
export default class ViewNew extends Vue {
  public title!: string;
  public back!: string;
  public status!: FormStatus;
  public sentTitle?: string;

  public formStatus = FormStatus;

  public icons = {
    faTimes,
    faCheckCircle,
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.slide-enter-active {
  animation: slide-in 0.3s;
}
.slide-leave-active {
  animation: slide-in 0.3s reverse;
}
@keyframes slide-in {
  0% {
    transform: translate(0, 100%);
  }
  100% {
    transform: translate(0, 0%);
  }
}

.fade-enter-active {
  animation: fade-in 0.7s;
}
.fade-leave-active {
  animation: fade-in 0.7s reverse;
}
@keyframes fade-in {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

.modal {
  position: fixed;
  width: 100%;
  height: 100%;
  left: 0;
  top: 0;
  background-color: #00000080;

  display: grid;

  grid-template-columns: 1fr auto 1fr;
  grid-template-rows: 1fr auto;

  grid-template-areas:
    ". 	. 		."
    ". 	modal 	.";

  .box {
    width: calc(#{$max_popup_width} - 2 *#{$standard_margin});
    min-height: 100px;

    padding: $standard_margin;

    background-color: $light_bg;
    grid-area: modal;
    box-sizing: border-box;

    position: relative;

    .done {
      .icon {
        color: $green;
        display: block;
        margin: auto;
        font-size: 100px;
        margin-bottom: $standard_spacing;
      }
    }

    span {
      display: block;
      margin-bottom: $standard_margin;
      position: relative;

      font-size: 20px;
      font-weight: bold;
      color: $black_text;

      .close {
        position: absolute;
        right: 0px;
        text-decoration: none;
        color: $black_text;
      }
    }
  }
}
</style>
